/*
	Grafica.java
*/

import java.awt.*;
import java.util.*;
import java.awt.event.*;
import java.awt.Image;


public class Grafica extends Canvas  {




	private String titulo,ejeX,ejeY;
	private int origenX=35,origenY=250, TamEjeX=400,TamEjeY=220;
	private Vector puntos;
	private double xmax=0,ymax=0;
	

public Grafica(String titul, String ejX, String ejY)
{
	titulo=titul;ejeX=ejX;ejeY=ejY;
	puntos =new Vector();
	puntos.addElement(new datoGrafica(0,0));
}

public void paint( Graphics g )
{
	g.setColor(new Color(240,240,240));

	for (int i=0;i<=9;i++)//dibuja fondo del diagrama de ocupacion
		{
			for (int j=0;j<=15;j++){
				g.setColor(new Color(250-36+3*i,250-1*j,250-2*j));
				g.fillRect(origenX+j*TamEjeX/16,origenY-TamEjeY+i*TamEjeY/10,TamEjeX/16,TamEjeY/10);
			}
		}	

	
	g.setColor(new Color(0,0,0));
	g.drawLine(origenX, origenY-TamEjeY, origenX,origenY);//pinta ejes
	g.drawLine(origenX, origenY, origenX+TamEjeX,origenY);

	g.setFont(new Font("Verdana", Font.BOLD, 15));
	g.drawString(titulo,origenX+70,origenY-230);//pinta ttulo
	g.drawString(ejeY,15,30);
	g.drawString(ejeX,origenX+TamEjeX/2,origenY+30);

	int r=5;
	for(int i=1;i<=r;i++)//pinta separadores de ejes
	{
		g.drawLine(origenX-3, origenY-(int)Math.round(0.95*i*TamEjeY/r) , origenX+2, origenY-(int)Math.round(0.95*i*TamEjeY/r) );	
		g.drawLine(origenX+(int)Math.round(0.95*i*TamEjeX/r), origenY-2 , origenX+(int)Math.round(0.95*i*TamEjeX/r), origenY+3 );

	}
	g.setFont(new Font("Verdana", Font.PLAIN, 9));


	if (ymax>0)	
	{		
	for(int i=1;i<=r;i++)//pinta los valores de los separadores de ejes
	{
		if (ymax>=10){g.drawString( ""+ (Math.round(i*ymax*100/r)/100.0),  origenX-35,  origenY-(int)Math.round(0.95*i*TamEjeY/r) +5);}
		else g.drawString( ""+ (Math.round(i*ymax*1000/r)/1000.0),  origenX-35,  origenY-(int)Math.round(0.95*i*TamEjeY/r) +5);	

	}	
	}//end if
	
	if ((xmax>0))	
	{		
	for(int i=1;i<=r;i++)//pinta los valores de los separadores de ejes
	{
		if (xmax>=10){g.drawString( ""+ (Math.round(i*xmax*100/r)/100.0),  origenX+(int)Math.round(0.95*i*TamEjeX/r)-8, origenY+13 );}
		else g.drawString( ""+ (Math.round(i*xmax*1000/r)/1000.0),  origenX+(int)Math.round(0.95*i*TamEjeX/r)-8, origenY+13 );	

	}	
	}//end if		
	g.setColor(new Color(230,230,230));	
	if(puntos.size()>1)for(int i=0;i<puntos.size();i++)//pinta proyecciones sobre los ejes
	{
		g.drawLine(origenX+(int)Math.round(0.95*TamEjeX*(((datoGrafica)puntos.elementAt(i)).getX())/xmax), origenY-(int)Math.round(0.95*TamEjeY*(((datoGrafica)puntos.elementAt(i)).getY())/ymax), origenX+1,origenY-(int)Math.round(0.95*TamEjeY*(((datoGrafica)puntos.elementAt(i)).getY())/ymax));
		g.drawLine(origenX+(int)Math.round(0.95*TamEjeX*(((datoGrafica)puntos.elementAt(i)).getX())/xmax), origenY-(int)Math.round(0.95*TamEjeY*(((datoGrafica)puntos.elementAt(i)).getY())/ymax), origenX+(int)Math.round(0.95*TamEjeX*(((datoGrafica)puntos.elementAt(i)).getX())/xmax),origenY-1);
	}


	g.setColor(new Color(0,0,0));
	if(puntos.size()>1)for(int i=1;i<puntos.size();i++)//pinta lineas de la grafica
	{
		g.drawLine(origenX+(int)Math.round(0.95*TamEjeX*(((datoGrafica)puntos.elementAt(i)).getX())/xmax), origenY-(int)Math.round(0.95*TamEjeY*(((datoGrafica)puntos.elementAt(i)).getY())/ymax) , origenX+(int)Math.round(0.95*TamEjeX*(((datoGrafica)puntos.elementAt(i-1)).getX())/xmax), origenY-(int)Math.round(0.95*TamEjeY*(((datoGrafica)puntos.elementAt(i-1)).getY())/ymax) );
	}
		
	
	g.setColor(new Color(30,30,240));		
	if(puntos.size()>1)for(int i=0;i<puntos.size();i++)//pinta puntos de la grafica
	{
	
    	g.fillOval(origenX+(int)Math.round(0.95*TamEjeX*(((datoGrafica)puntos.elementAt(i)).getX())/xmax)-2, 
		   origenY-(int)Math.round(0.95*TamEjeY*(((datoGrafica)puntos.elementAt(i)).getY())/ymax)-2,
		   5, 
		   5);  	   
	}
	
	g.setColor(new Color(0,0,0));
	g.drawLine(origenX, origenY-TamEjeY, origenX,origenY);
	g.drawLine(origenX, origenY, origenX+TamEjeX,origenY);

}

public void addPunto(double x, double y)
{
	if(x>xmax)xmax=x;
	if(y>ymax)ymax=y;
	puntos.addElement(new datoGrafica(x,y));
	repaint();
}

public void reset()
{
	puntos =new Vector();
	puntos.addElement(new datoGrafica(0,0));
	xmax=0;
	ymax=0;	
	repaint();
}

public String getId()
{return ""+ejeX+ejeY;
}


}//acaba clase Grafica



class datoGrafica
{
private double x,y;
public datoGrafica(double i, double ii)
{
	x=i;
	y=ii;	
}

public double getX(){return x;}
public double getY(){return y;}


}

